Python AutoCAD 块组

系统 313 0

本文不定期更新!

目 录

    • 0、相关文章
    • 1、连接及库导入
    • 2、块
      • (1) 创建新块
      • (2) 添加图元到块
      • (3) 插入块
        • ① 从当前文件中插入块
        • ② 外部文件作为块插入
      • (4) 添加属性到块
        • ① 当前文件创建的块属性添加
        • ② 外部文件作为插入块的属性添加
      • (5) 已有块属性的读取
    • 3、组
      • (1) 创建新组
    • 4、尾声

0、相关文章

  • Python pyautocad库 使用简介
  • Python AutoCAD 系统设置
  • Python AutoCAD 图层
  • Python AutoCAD 绘图
  • Python AutoCAD 修改
  • Python AutoCAD 块组
  • Python AutoCAD 注释
  • Python AutoCAD 文件
  • Python AutoCAD 选择集

1、连接及库导入

            
              
                #!/usr/bin/env python
              
              
                # -*- coding: utf-8 -*-
              
              
                '''
=============================
Author = Hulunbuir & DalaiNur
Email: liyang@alu.hit.edu.cn
Last Update: 2019.08.29 11:00
=============================
'''
              
              
                from
              
               pyautocad 
              
                import
              
               Autocad

acad 
              
                =
              
               Autocad
              
                (
              
              create_if_not_exists 
              
                =
              
              
                True
              
              
                )
              
              
acad
              
                .
              
              prompt
              
                (
              
              
                "Hello! AutoCAD from pyautocad."
              
              
                )
              
              
                print
              
              
                (
              
              acad
              
                .
              
              doc
              
                .
              
              Name
              
                )
              
            
          

2、块

创建的是Block。

(1) 创建新块

            
              grip 
              
                =
              
               APoint
              
                (
              
              
                20
              
              
                ,
              
              
                0
              
              
                )
              
              
blockObj 
              
                =
              
               acad
              
                .
              
              ActiveDocument
              
                .
              
              Blocks
              
                .
              
              Add
              
                (
              
              grip
              
                ,
              
              
                "HIT_Block"
              
              
                )
              
              
                # 新建块的名称为"HIT_Block";
              
              
                # grip为块定位夹点所在位置。
              
            
          

(2) 添加图元到块

            
              center 
              
                =
              
               APoint
              
                (
              
              
                0
              
              
                ,
              
              
                0
              
              
                )
              
              
radius 
              
                =
              
              
                10
              
              
CircleObj 
              
                =
              
               blockObj
              
                .
              
              AddCircle
              
                (
              
              center
              
                ,
              
               radius
              
                )
              
              
center 
              
                =
              
               APoint
              
                (
              
              
                40
              
              
                ,
              
              
                10
              
              
                )
              
              
majAxis 
              
                =
              
               APoint
              
                (
              
              
                10
              
              
                ,
              
              
                0
              
              
                ,
              
              
                0
              
              
                )
              
              
EllObj 
              
                =
              
               blockObj
              
                .
              
              AddEllipse
              
                (
              
              center
              
                ,
              
               majAxis
              
                ,
              
              
                0.5
              
              
                )
              
            
          

(3) 插入块

Block插入到图纸空间后为BlockReference。

① 从当前文件中插入块

            
              insertionPnt 
              
                =
              
               APoint
              
                (
              
              
                0
              
              
                ,
              
              
                0
              
              
                )
              
              
RetVal 
              
                =
              
               acad
              
                .
              
              model
              
                .
              
              InsertBlock
              
                (
              
              insertionPnt
              
                ,
              
              
                "HIT_Block"
              
              
                ,
              
              
                1
              
              
                ,
              
              
                1
              
              
                ,
              
              
                1
              
              
                ,
              
              
                0
              
              
                )
              
              
                # acad.model.InsertBlock(InsertionPoint, Name, Xscale, Yscale, ZScale, Rotation);
              
              
                # insertionPnt为块的插入点,即块的定位夹点与图纸空间中的该点对齐。
              
            
          

② 外部文件作为块插入

            
              insertionPnt 
              
                =
              
               APoint
              
                (
              
              
                10
              
              
                ,
              
              
                0
              
              
                )
              
              
RetVal 
              
                =
              
               acad
              
                .
              
              model
              
                .
              
              InsertBlock
              
                (
              
              insertionPnt
              
                ,
              
              
                "D:\AutoCAD\Harbin.dwg"
              
              
                ,
              
              
                1
              
              
                ,
              
              
                1
              
              
                ,
              
              
                1
              
              
                ,
              
              
                0
              
              
                )
              
              
                # 外部文件名尽量与当前文件中的各块名称不同;
              
              
                # 插入后外部文件名将作为其在当前文件中的块名;
              
              
                # 外部文件的坐标原点为其作为块的定位夹点。
              
            
          

(4) 添加属性到块

① 当前文件创建的块属性添加

            
              height 
              
                =
              
              
                1
              
              
                # 字高
              
              
mode 
              
                =
              
              
                2
              
              
                # 模式
              
              
prompt 
              
                =
              
              
                "Attribute_Prompt"
              
              
                # 提示
              
              
insertionPoint 
              
                =
              
               APoint
              
                (
              
              
                0
              
              
                ,
              
              
                0
              
              
                )
              
              
tag 
              
                =
              
              
                "Attribute_Tag"
              
              
                # 标记
              
              
value 
              
                =
              
              
                "Attribute_Value"
              
              
                # 默认
              
              
attributeObj 
              
                =
              
               blockObj
              
                .
              
              AddAttribute
              
                (
              
              height
              
                ,
              
               mode
              
                ,
              
               prompt
              
                ,
              
               insertionPoint
              
                ,
              
               tag
              
                ,
              
               value
              
                )
              
            
          

② 外部文件作为插入块的属性添加

            
              blocks_nums 
              
                =
              
               acad
              
                .
              
              ActiveDocument
              
                .
              
              Blocks
              
                .
              
              count
       
              
                # 图纸空间中块的总数目
              
              
blocks_names 
              
                =
              
              
                [
              
              acad
              
                .
              
              ActiveDocument
              
                .
              
              Blocks
              
                .
              
              Item
              
                (
              
              i
              
                )
              
              
                .
              
              Name 
              
                for
              
               i 
              
                in
              
              
                range
              
              
                (
              
              blocks_nums
              
                )
              
              
                ]
              
              
                # 图纸空间所有块的名称组成的列表
              
              
index 
              
                =
              
               blocks_names
              
                .
              
              index
              
                (
              
              
                "Harbin"
              
              
                )
              
              
                # 外部文件块"Harbin"在图纸空间块中的索引号
              
              
external_blockObj 
              
                =
              
               acad
              
                .
              
              ActiveDocument
              
                .
              
              Blocks
              
                .
              
              Item
              
                (
              
              index
              
                )
              
              
                # external_blockObj即为外部插入到本地文件中的块
              
              
ex_att_Obj 
              
                =
              
               external_blockObj
              
                .
              
              AddAttribute
              
                (
              
              height
              
                ,
              
               mode
              
                ,
              
               prompt
              
                ,
              
               insertionPoint
              
                ,
              
               tag
              
                ,
              
               value
              
                )
              
            
          

(5) 已有块属性的读取

            
              
                '''
# RetVal = object.GetAttributes() 此方法在不借助其他库的情况下如何使用暂时未知;
# 采用把块炸开将属性部分暴露出来,然后提取其相关信息的方式获取属性信息;
# 此方式虽然曲折,但至少可行;
# 为了清晰直观,文本代码暂未考虑效率问题,故代码行数较多。
'''
              
              
                # 不采用如下方式,直接炸开块会报错。
              
              
                try
              
              
                :
              
              
    RetVal
              
                .
              
              Explode
              
                (
              
              
                )
              
              
                # 炸开块
              
              
                except
              
              
                :
              
              
    RetVal
              
                .
              
              Delete
              
                (
              
              
                )
              
              
                # 删除重复
              
              
                for
              
               obj 
              
                in
              
               acad
              
                .
              
              iter_objects
              
                (
              
              
                "AttributeDefinition"
              
              
                )
              
              
                :
              
              
                # 以下获取块的属性信息
              
              
                # 如果想获取某一特定块的属性信息可以用ObjectID识别特定块
              
              
                print
              
              
                (
              
              obj
              
                .
              
              ObjectName
              
                )
              
              
                print
              
              
                (
              
              obj
              
                .
              
              TagString
              
                )
              
              
                print
              
              
                (
              
              obj
              
                .
              
              TextString
              
                )
              
              
                print
              
              
                (
              
              obj
              
                .
              
              PromptString
              
                )
              
              
                " # *********************************************** 2、组 ************************************************ # "
              
            
          

3、组

(1) 创建新组

            
              groupObj 
              
                =
              
               acad
              
                .
              
              ActiveDocument
              
                .
              
              Groups
              
                .
              
              Add
              
                (
              
              
                "Harbin Institute of Technology"
              
              
                )
              
              
                # 新建组的名称为"Harbin Institute of Technology"
              
            
          

4、尾声

以上,便是关于 AutoCAD块组 的一些基本代码,因篇幅有限,某些非关键功能未做详细介绍,如有疑问,欢迎邮件来询。

本文部分功能的实现离不开广大博友的大力帮助,有些功能看似简单,但第一次实现出来却是相当不容易的。

鉴于,相关示例代码相对较少,特写本文,一方面是为自己的阶段性学习做一个总结,另一方面更是为有需要的人提供多一点参考。

如果您已实现一些本文未提及的功能,还请在评论区呈现,以便为后续学习者提供更多的帮助。

胸藏文墨怀若谷,腹有诗书气自华,希望各位都能在知识的pāo子里快乐徜徉。

因本人野生学习Python,水平确实有限,文中难免有所疏漏,还请各位大神不吝批评指正。

最后,祝各位攻城狮们,珍爱生命,保护发际线!

本文部分内容,源于网络!

欢迎大家点赞、评论及转载,转载请注明出处!

为我打call,不如为我打款!

打赏可备注邮箱,本人会将上述代码发送给各位土豪!

Python AutoCAD 块组_第1张图片


更多文章、技术交流、商务合作、联系博主

微信扫码或搜索:z360901061

微信扫一扫加我为好友

QQ号联系: 360901061

您的支持是博主写作最大的动力,如果您喜欢我的文章,感觉我的文章对您有帮助,请请扫描上面二维码支持博主1元、2元、5元等您想捐的金额吧,狠狠点击下面给点支持吧

发表我的评论
最新评论 总共0条评论